library(rugarch)

sp500 <- read.table("sp500.dat")
gs <- read.table("goldmanSacks.dat")
ford <- read.table("ford.dat")

# Add name "Data" in Line 1 in sp500.dat, then
D <- read.table("sp500.dates")
t <- D[,1]
D <- strptime(t, "%Y-%m-%d") #convert to  POSIXlt (a date class)
D <- D[2:659]

ps.options(horizontal=F, width=4.8, height=5, pointsize=9)
postscript("Fig312.eps", onefile=F, print=F)
par(mar=c(3,3,3,1),mfrow=c(3,1), mgp=c(1.8,0.6,0))

library(rugarch)
m1 = ugarchspec(variance.model=list(model="eGARCH", garchOrder=c(1,1)),  mean.model=list(armaOrder=c(0,0), include.mean=F))
sp500EG=ugarchfit(m1, 100*diff(log(sp500[,6])))
gsEG=ugarchfit(m1, 100*diff(log(gs[,6])))
fordEG=ugarchfit(m1, 100*diff(log(ford[,6])))


D <- D[2:658]
plot(D, 100*diff(log(sp500[,6])), type='l', xlab='', ylab='', ylim=c(-8.5, 6.5), 
    main='Daily returns of S&P500 index', col="blue")
lines(D, 2*sigma(sp500EG), col="red")
lines(D, -2*sigma(sp500EG), col="red")

plot(D, 100*diff(log(gs[,6])), type='l', xlab='', ylab='', 
    main='Daily returns of Goldman Sacks stock', col="blue")
lines(D, 2*sigma(gsEG), col="red")
lines(D, -2*sigma(gsEG), col="red")

plot(D, 100*diff(log(ford[,6])), type='l', xlab='', ylab='', 
        main='Daily returns of Ford stock', col="blue")
lines(D, 2*sigma(fordEG), col="red")
lines(D, -2*sigma(fordEG), col="red")
dev.off()

cat(length(sigma(sp500EG)[(2*sigma(sp500EG))>=abs(100*diff(log(sp500[,6])))])/length(sigma(sp500EG)), "\n")
cat(length(sigma(gsEG)[(2*sigma(gsEG))>=abs(100*diff(log(gs[,6])))])/length(sigma(gsEG)), "\n")
cat(length(sigma(fordEG)[(2*sigma(fordEG))>=abs(100*diff(log(ford[,6])))])/length(sigma(fordEG)))
